/*
 * lilJudd
 * Copyright (C) 2023 moonleay
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package net.moonleay.lilJudd.extensions

import com.kotlindiscord.kord.extensions.commands.Arguments
import com.kotlindiscord.kord.extensions.commands.application.slash.converters.impl.enumChoice
import com.kotlindiscord.kord.extensions.extensions.Extension
import com.kotlindiscord.kord.extensions.extensions.publicSlashCommand
import net.moonleay.lilJudd.extensions.component.SplatoonOnlineMode
import net.moonleay.lilJudd.util.Logger

class RotationExtension : Extension() {

    override val name = "rotation"
    override val allowApplicationCommandInDMs: Boolean
        get() = false


    override suspend fun setup() {
        publicSlashCommand(::RotationArguments) {
            name = "rotation"
            description = "Check the current rotations"
            this.action {
                val mode = this.arguments.mode
                when (mode) {
                    SplatoonOnlineMode.ALL -> {

                    }

                    SplatoonOnlineMode.REGULAR -> {

                    }

                    SplatoonOnlineMode.SERIES -> {

                    }

                    SplatoonOnlineMode.OPEN -> {

                    }

                    SplatoonOnlineMode.X -> {

                    }

                    SplatoonOnlineMode.SALMON_RUN -> {

                    }
                }

                Logger.out("Done")
            }
        }
    }

    inner class RotationArguments : Arguments() {

        val mode by enumChoice<SplatoonOnlineMode> {
            this.name = "mode"
            this.description = "The mode you want to check the rotation for"
            this.typeName = "en_US"
        }
    }
}
